<route lang="yaml">
meta:
  enabled: false
</route>

<script lang="ts" setup name="biz">
import type { FormInstance, FormRules } from 'element-plus'
import { ElMessage } from 'element-plus'
import { createBiz, getBizById, updateBiz } from '@/api/biz/bizApi'
const emit = defineEmits(['success'])

const formRef = ref<FormInstance>()
const formRules = ref<FormRules>({
  bizTitle: [
    { required: true, message: '请输入业务模型名称', trigger: 'blur' },
  ],
  bizDesc: [
    { required: false, message: '请输入描述', trigger: 'blur' },
  ],
})

const state = reactive({
  title: '',
  dialogVisible: false,
  loading: false,
  formData: {
    bizId: 1,
    bizTitle: '',
    bizDesc: '',
  },
  actionType: 1,
})

onMounted(() => {})

const getData = async (bizId: number) => {
  state.loading = true
  const { data } = await getBizById(bizId)
  state.loading = false
  state.formData = data
}

function onSubmit() {
  formRef.value && formRef.value.validate(async (valid) => {
    if (valid) {
      if (state.actionType === 1) {
        const { msg } = await createBiz(state.formData)
        ElMessage.success(msg)
        state.dialogVisible = false
        emit('success')
      }
      else {
        const { msg } = await updateBiz(state.formData)
        ElMessage.success(msg)
        state.dialogVisible = false
        emit('success')
      }
    }
  })
}

function onCancel() {
  state.dialogVisible = false
}

function resetFormData() {
  state.formData = {
    bizId: -1,
    bizTitle: '',
    bizDesc: '',
  }
}

defineExpose({
  showAddModel() {
    resetFormData()
    state.title = '新增业务模型'
    state.actionType = 1
    state.dialogVisible = true
  },
  showEditModel(bizId: any) {
    resetFormData()
    state.title = '编辑业务模型'
    state.actionType = 2
    state.dialogVisible = true
    getData(bizId)
  },

})
</script>

<template>
  <el-drawer v-model="state.dialogVisible" :title="state.title" size="30%">
    <el-scrollbar class="form-el-scrollbar">
      <div v-loading="state.loading">
        <el-form ref="formRef" :model="state.formData" :rules="formRules" label-width="120px" label-suffix="：">
          <el-form-item label="模型名称" prop="bizTitle">
            <el-input v-model="state.formData.bizTitle" placeholder="业务模型名称" />
          </el-form-item>

          <el-form-item label="简要说明" prop="bizDesc">
            <el-input v-model="state.formData.bizDesc" type="textarea" rows="10" placeholder="请输入标题" />
          </el-form-item>
        </el-form>
      </div>
    </el-scrollbar>

    <template #footer>
      <el-button size="large" @click="onCancel">
        取消
      </el-button>
      <el-button type="primary" size="large" @click="onSubmit">
        保存
      </el-button>
    </template>
  </el-drawer>
</template>
